require 'fox16'
require 'Debugger'

include Fox
include Mondrian::Managers

module Mondrian

  class BreakpointFrame < Dockable
		attr_accessor :slave
		
		def initialize(parent)	
			super(parent)
			self.title = "Breakpoints"
			frame = FXHorizontalFrame.new(self, LAYOUT_FILL_X | LAYOUT_FILL_Y | FRAME_THICK, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
			@list = FXList.new(frame, nil, 0, FRAME_NORMAL | LIST_BROWSESELECT | LAYOUT_FILL_X | LAYOUT_FILL_Y)
			@slave = nil			
			Debugger.instance.subscribe_all(self, method(:on_debugger_change))
			Debugger.instance.breakpoints.each { |bp| add_breakpoint(bp) }
			list_changed
		end
		
		def add_breakpoint(breakpoint)
			@list.appendItem(breakpoint.inspect, nil, breakpoint)			
		end
		
		def on_debugger_change(sender, message, breakpoint)
			case message
				when :breakpoint_added
					add_breakpoint(breakpoint)
				when :breakpoint_removed
					(@list.numItems-1).downto(0) do |idx|
						@list.removeItem(idx) if @list.getItem(idx).data == breakpoint
					end					
			end
			list_changed
		end
		
		def list_changed
			@list.sortItems
		end
	end
end