require 'fox16'

require 'SessionManager'
require 'IconManager'
require 'FileManager'
require 'framework/protogui/workspacebrowser'
require 'framework/project'

include Fox

module Mondrian
	class FXWorkspaceBrowser < Dockable
		def initialize(parent)
			super(parent)

			frame = FXHorizontalFrame.new(self, LAYOUT_FILL_X | LAYOUT_FILL_Y | FRAME_THICK, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)

			self.title = "Workspace Browser"

            #@workspace = WorkspaceBrowser.new('c:\\documents and settings\\oliver\\sandbox') #FIXME

			@tree = FXTreeList.new(frame, nil, 0, (TREELIST_BROWSESELECT | 
                                   TREELIST_SHOWS_LINES | 
                                   TREELIST_SHOWS_BOXES |
                                   TREELIST_ROOT_BOXES | 
                                   LAYOUT_FILL_X | 
                                   LAYOUT_FILL_Y))
			
			#@workspace.project_folders.each { |path|
			#    p = Project.new(path)
			#    node = @tree.appendItem(nil, p.name)
			#    add_project_entries(p, node)
			#}
			
            #@tree.connect(SEL_DOUBLECLICKED, method(:onDoubleClicked))

            SessionManager.instance.subscribe_all(self, method(:update))
		end
		
		
		def add_project_entries(project, node, spath = nil)
		     spath = project.path unless spath
		     
			 project.folders(spath).each { |path|
			     last = @tree.appendItem(node, File.basename(path))
			     add_project_entries(project, last, path)
			 }
			 project.files(spath).each { |path|
			     @tree.appendItem(node, File.basename(path))
			 }
		end


        def slave=(slave)
            @slave = slave
        end
        
        
        def update(sender, message, data)
            
        end
	end
end
